%% 2015 DEC 5
% Solving MaOPs using weighted sum scalarizing functions
% Issue 1: parameter wZone (control region of a search direction) plays an important role remains  Solved
% Issue 2: the effect of mating restriction:   Solved
% Issue 3: the number of replacements is restricted. The aim is to avoid the case that a solution replace two
% many solutions which makes the whole population less diversified. However, this seems not effective.

% This version nakes comparion with Chebyshev based method
clear all; close all; clc
fprintf('Starting: \n');
warning off all
all_path = pwd;
addpath([pwd,'-begin']);
savepath;
%% Parameter settings
maxGen = 100;
testType = 3; testNo = 45; M = 2;
%% generate search directions
load('wmtx2');
SD = wmtx;


%% Search directions TO weights
jointWD = SD;
jointWnum = size(jointWD,1);
jointFnum = jointWnum;
N = jointFnum;
T = round(min([10,N*0.1]));
WdegreeMatrix = neighboringWW(jointWD,T);
%% problem configuration
N = jointFnum;
nVar = 100;
bounds=[zeros(1, nVar); 2*(1:nVar)];
s_bounds = 2*ones(1,M);


load (['E:\MOEDpaper\MOGAfunctionLib\TruePFWFG4\WFG',num2str(testNo),'.mat'])
normpStar = pStar;
Fbounds = 1.2*s_bounds;

for iRunindex = 1:2
    switch iRunindex
        case 1
            eval(['eval_subPBI']);
        case 2
            eval(['eval_subLPBI']);
    end
    %% Compute results
    num = size(showbestobjv,1);
    normshowHobjv = showbestobjv./repmat(s_bounds,[num 1]);
    nadir =2*ones(1,M);
    HVRun(iRunindex)  = Hypervolume_MEX(showbestobjv./repmat(nadir,[num 1]), 1.1*ones(1,M));
    result{iRunindex} = showHobjv;
    resultoffline{iRunindex} = showbestobjv;
end

if 1==1
    C = [cMetric(result{1},result{2}),cMetric(result{2},result{1})];
    figure
    temp1 = resultoffline{1}; temp2 = resultoffline{2};
    plot(temp1(:,1),temp1(:,2),'rd',temp2(:,1),temp2(:,2),'bo',normpStar(:,1),normpStar(:,2),'k.'), axis square; legend('PBI','LPBI','PF')
    grid on
    if M==3
        subplot(121)
        plot3(temp1(:,1),temp1(:,2),temp1(:,3),'ro'), grid on; view(135,12);
        hold on
        plot3(normpStar(:,1),normpStar(:,2),normpStar(:,3),'k*');
        %plot3(jointWDSource(:,1),jointWDSource(:,2),jointWDSource(:,3),'bo');ԭ棡
        grid on;  view(135,12);
        axis square
        %axis([0 1 0 1 0 1]) ;
        axis([0 2 0 2 0 2]) ;
        %axis([0 0.6 0 0.6 0 0.6])
        subplot(122)
        plot3(temp2(:,1),temp2(:,2),temp2(:,3),'ro');
        plot3(normpStar(:,1),normpStar(:,2),normpStar(:,3),'k*');
        grid on; view(135,12);
        axis square
        %axis([0 1 0 1 0 1]) ;
        axis([0 2 0 2 0 2]) ;
        %axis([0 0.6 0 0.6 0 0.6])
    end
end

